try:
    import psycopg2
except:
    pass

from _eole_password import EolePassword

class EolePgPwd(EolePassword):
    """
    Postgresql password operations and manipulation.
    """
    def __init__(self, name, host):
        self.dbc = None
        EolePassword.__init__(self, name)

    def open_dbc(self):
        """ Open a Data Base connection (dbc)

        This is a private class used by EolePgPwd class do not use.
        """
        conf = MAIN_CONF.get_conf("pgsql")
        host = conf['pgsql-dbhost']
        user = conf['pgsql-dbuser']
        pwd = conf['pgsql-dbpass']

        if 'pgsql-port' in conf:
            port = conf['pgsql-dbport']
        else:
            port = "5432"

        try:
            conn_str = "dbname='template1' user=" + user
            if host != "localhost":
                conn_str += " host='" + host + "'"
            conn_str += " password='" + pwd + "'"
            self.dbc = psycopg2.connect(conn_str)
        except psycopg2.OperationalError:
            msg = "Unable to open connection to posgresql server"
            print("ERROR 10: {0} : {1}".format(msg, host))
            raise EolePwdError("%s" % (msg))

    def close_dbc(self):
        """ Close the Data Base connection (dbc)

        This is a private class used by EolePgPwd class do not use.
        """
        if self.dbc:
            self.dbc.close()

    def run_req(self, request):
        """ Run a SQL request on opened DBCO

        This is a private class used by EolePgPwd class do not use.
        """
        try:
            cursor = self.dbc.cursor()
            affected_rows = cursor.execute(request)
            if affected_rows > 0:
                res = cursor.fetchone()
                if res:
                    return res
                else:
                    return True
            else:
                print("WARN 1 : Running SQL request failed")
                return None
        except:
            return None

    def get_user_info(self):
        if not self.dbc:
            self.open_dbc()

        req_opwd = "SELECT passwd "
        req_opwd += "FROM pg_user "
        req_opwd += "WHERE username = '%s'" % self.user
#        if self.user != "root":
#            req_opwd += "AND Host = '%s'" % self.host

        print(req_opwd)

        self.old_pass = self.run_req(req_opwd)
        if self.old_pass:
            return True
        else:
            return False

